#include "Ballet128128_coreD.h"

static  const unsigned char _C_ALIGN32(Lbswap_mask[32]) = {
	  3, 2, 1, 0, 11, 10, 9, 8, 7, 6, 5,4, 15, 14, 13, 12,  3, 2, 1, 0, 11, 10, 9, 8, 7, 6, 5,4, 15, 14, 13, 12,
};
static  const unsigned char  _C_ALIGN32(Lbswap_maskb[32]) = {
	 7, 6, 5,4, 3, 2, 1, 0,  15, 14, 13, 12,11, 10, 9, 8, 7, 6, 5,4, 3, 2, 1, 0,  15, 14, 13, 12,11, 10, 9, 8,
};


#define ROTL32_AVX2(a,n)\
_mm256_or_si256( _mm256_slli_epi32(a, n),_mm256_srli_epi32(a, 32-n))  

#define BalletLoadData128(D0,D1,D2,D3,pt,E0,E1,E2,E3)\
      D0= _mm256_loadu_si256((__m256i*)(pt));\
      D1= _mm256_loadu_si256((__m256i*)(pt+32)); \
      D2= _mm256_loadu_si256((__m256i*)(pt+32*2)); \
      D3= _mm256_loadu_si256((__m256i*)(pt+32*3)); \
    E0=  _mm256_unpacklo_epi32(D0, D1);\
    E2=  _mm256_unpackhi_epi32(D0, D1);\
    E1=  _mm256_unpacklo_epi32(D2, D3);\
    E3=  _mm256_unpackhi_epi32(D2, D3);\
     D0=  _mm256_unpacklo_epi32(E0, E1);\
     D1=  _mm256_unpackhi_epi32(E0, E1);\
     D2=  _mm256_unpacklo_epi32(E2, E3);\
     D3=  _mm256_unpackhi_epi32(E2, E3);\
    D0 = _mm256_shuffle_epi8( D0,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
     D1 = _mm256_shuffle_epi8( D1,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
    D2 = _mm256_shuffle_epi8( D2,  _mm256_load_si256((__m256i*) Lbswap_mask ));\
     D3 = _mm256_shuffle_epi8( D3,  _mm256_load_si256((__m256i*) Lbswap_mask )); 

#define BalletOutputData128A(D0,D1,D2,D3,E0,E1,E2,E3)\
     E0=  _mm256_unpacklo_epi32(D0, D2);\
     E1=  _mm256_unpackhi_epi32(D0, D2);\
     E2=  _mm256_unpacklo_epi32(D1, D3);\
     E3=  _mm256_unpackhi_epi32(D1, D3);\
\
     D0=  _mm256_unpacklo_epi32(E0, E2);\
     D1=  _mm256_unpackhi_epi32(E0, E2);\
     D2=  _mm256_unpacklo_epi32(E1, E3);\
     D3=  _mm256_unpackhi_epi32(E1, E3);\
     D0 = _mm256_shuffle_epi8( D0,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
     D1 = _mm256_shuffle_epi8( D1,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
    D2 = _mm256_shuffle_epi8( D2,  _mm256_load_si256((__m256i*) Lbswap_maskb  ));\
     D3 = _mm256_shuffle_epi8( D3,  _mm256_load_si256((__m256i*) Lbswap_maskb )); 

#define BalletOutputData128(D0,D1,D2,D3,p,E0,E1,E2,E3)\
     E0=  _mm256_unpacklo_epi32(D0, D2);\
     E1=  _mm256_unpackhi_epi32(D0, D2);\
     E2=  _mm256_unpacklo_epi32(D1, D3);\
     E3=  _mm256_unpackhi_epi32(D1, D3);\
\
     D0=  _mm256_unpacklo_epi32(E0, E2);\
     D1=  _mm256_unpackhi_epi32(E0, E2);\
     D2=  _mm256_unpacklo_epi32(E1, E3);\
     D3=  _mm256_unpackhi_epi32(E1, E3);\
     D0 = _mm256_shuffle_epi8( D0,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
     D1 = _mm256_shuffle_epi8( D1,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
    D2 = _mm256_shuffle_epi8( D2,  _mm256_load_si256((__m256i*) Lbswap_maskb  ));\
     D3 = _mm256_shuffle_epi8( D3,  _mm256_load_si256((__m256i*) Lbswap_maskb ));\
	 _mm256_storeu_si256((__m256i*)(p  ), D0);\
    _mm256_storeu_si256((__m256i*)(p+32*1), D1);\
     _mm256_storeu_si256((__m256i*)(p +32*2 ), D2);\
    _mm256_storeu_si256((__m256i*)(p+32*3), D3); 	

#define BytesperEnc 128
#define BytesperEnc2 256



#define BalletRFDecB(a,b,c,d,t0,t1,p)\
	  c=_mm256_xor_si256(c, (*(p)) ); \
	  b=_mm256_xor_si256(b, (*(p+1)) ); \
	  t0 = _mm256_xor_si256(b,c);\
	  \
	  a=  _mm256_sub_epi32(a, ROTL32_AVX2(t0, 9));\
	  a=  ROTL32_AVX2(a,26);\
	  d=  _mm256_sub_epi32(d, ROTL32_AVX2(t0, 14));\
	  d =ROTL32_AVX2(d,17);\
\
	  d=_mm256_xor_si256(d, (*(p+2)) ); \
	  a=_mm256_xor_si256(a, (*(p+3)) );\
	  t1 = _mm256_xor_si256(a,d);\
	  b=  _mm256_sub_epi32(b, ROTL32_AVX2(t1, 9));\
	  c=  _mm256_sub_epi32(c, ROTL32_AVX2(t1, 14));	\
	  b = ROTL32_AVX2(b,26);\
	  c =ROTL32_AVX2(c, 17);

void BalletGenRK_128_128M_DEC(__m256i * Rk, u8i *K)
{
	u64i i;
	u64i  k0, k1;
	__m256i *p = (__m256i *)Rk;
	k0 = *((u64i *)K);
	k1 = *((u64i *)(K + 8));
	k0 = SWAP64(k0);
	k1 = SWAP64(k1);
 
		p += RoundBallet128128 * 2 - 1;
		for (i = 0; i < RoundBallet128128; i += 2) //һμ 
		{
			*p = _mm256_set1_epi32(k0 >> 32);
			*(p - 1) = _mm256_set1_epi32(k0 & 0x0ffffffff);
			k0 ^= ROTL64(k1, 3) ^ ROTL64(k1, 5) ^ i;
			*(p - 2) = _mm256_set1_epi32(k1 >> 32);
			*(p - 3) = _mm256_set1_epi32(k1 & 0x0ffffffff);
			k1 ^= ROTL64(k0, 3) ^ ROTL64(k0, 5) ^ (i + 1);
			p -= 4;
		} 

} 

void Ballet128128DecDataM(unsigned char *out, unsigned char *pt, unsigned char *trk)
{
	__m256i D0, D1, D2, D3, D4, D5, D6, D7;
	__m256i E0, E1, E2, E3;
	__m256i *p = (__m256i *)trk;
	__m256i *dst = p + RoundBallet128128 * 2;
	BalletLoadData128(D0, D1, D2, D3, pt, E0, E1, E2, E3);
	BalletLoadData128(D4, D5, D6, D7, pt + 16 * 8, E0, E1, E2, E3);

	while (p < dst)
	{
		BalletRFDecB(D0, D1, D2, D3, E0, E1, p);
		BalletRFDecB(D4, D5, D6, D7, E2, E3, p);
		p += 4;
	} 
	BalletOutputData128(D0, D1, D2, D3, out, E0, E1, E2, E3);
	BalletOutputData128(D4, D5, D6, D7, out + 16 * 8, E0, E1, E2, E3);
} 

void Ballet128128DecDataM_CBC(unsigned char *out, unsigned char *pt, unsigned char *trk, __m128i *IV)
{
	__m256i D0, D1, D2, D3, D4, D5, D6, D7;
	__m256i E0, E1, E2, E3,E4,E5,E6,E7;
	__m256i *p = (__m256i *)trk;
	__m256i *dst = p + RoundBallet128128 * 2;
	__m128i TX0;
	BalletLoadData128(D0, D1, D2, D3, pt, E0, E1, E2, E3);
	BalletLoadData128(D4, D5, D6, D7, pt + 16 * 8, E0, E1, E2, E3);

	while (p < dst)
	{
		BalletRFDecB(D0, D1, D2, D3, E0, E1, p);
		BalletRFDecB(D4, D5, D6, D7, E2, E3, p);
		p += 4;
	}
	TX0 = _mm_loadu_si128((__m128i*)(pt));
	E4 = _mm256_inserti128_si256(E0, *IV, 0);
	E4= _mm256_inserti128_si256(E4, TX0, 1);
	E5= _mm256_loadu_si256((__m256i*)(pt + 16));
	E6 = _mm256_loadu_si256((__m256i*)(pt + 16 * 3));
	E7 = _mm256_loadu_si256((__m256i*)(pt + 16 * 5));

	BalletOutputData128A(D0, D1, D2, D3, E0, E1, E2, E3);   
		_mm256_storeu_si256((__m256i*)(out), _mm256_xor_si256(D0, E4));
		_mm256_storeu_si256((__m256i*)(out + 32), _mm256_xor_si256(D1, E5));
		_mm256_storeu_si256((__m256i*)(out + 32 * 2), _mm256_xor_si256(D2, E6));
		_mm256_storeu_si256((__m256i*)(out + 32 * 3), _mm256_xor_si256(D3, E7)); 

		E4 = _mm256_loadu_si256((__m256i*)(pt + 16 * 7));
		E5 = _mm256_loadu_si256((__m256i*)(pt + 16 * 9));
		E6 = _mm256_loadu_si256((__m256i*)(pt + 16 * 11));
		E7 = _mm256_loadu_si256((__m256i*)(pt + 16 * 13));
		*IV = _mm_loadu_si128((__m128i*)(pt + 16 * 15));

	BalletOutputData128A(D4, D5, D6, D7, E0, E1, E2, E3);		 
	_mm256_storeu_si256((__m256i*)(out + 32 * 4), _mm256_xor_si256(D4, E4));
	_mm256_storeu_si256((__m256i*)(out + 32 * 5), _mm256_xor_si256(D5, E5));
	_mm256_storeu_si256((__m256i*)(out + 32 * 6), _mm256_xor_si256(D6, E6));
	_mm256_storeu_si256((__m256i*)(out + 32 * 7), _mm256_xor_si256(D7, E7));
}

