#include <stdio.h>
#include <string.h>
#ifdef __cplusplus
extern "C" {
#endif
#include "Ballet128128.h" 
#ifdef __cplusplus
}
#endif   

#define blocksize 128
#define keysize 128
void TestBallet128128_CBC(void);

int main()
{ 
	unsigned char ciphertext[32];
	unsigned char plaintext[32];
	unsigned char masterkey[32]; 
	int i;
	int out_len; 
	int in_len=blocksize/8;
	int keylen=keysize/8; 
	int round;
	memset(masterkey, 0, 32);
	memset(plaintext, 0, 32);
  // GenSampleTxt();
		plaintext[7]=1;
		plaintext[11]=2;
		plaintext[15]=3; 
		masterkey[7]=4;
		masterkey[15]=5;   
		round=RoundBallet128128;  
	
	printf("Ballet-%03d/%03d test vector:\n",blocksize,keysize );
	printf("masterkey is:\n");
	for(  i=0;i<keylen;i++)
		printf("%02X ", masterkey[i]);
	printf("\n"); 
	printf("encryption process:\n");
	printf("plaintext is:\n");
	for(  i=0;i<in_len;i++)
		printf("%02X ", plaintext[i]);
	printf("\n");  
	printf("\n");  
#ifdef OutputInnerPars
	for(i=1;i<=round;i++)
	{
		Crypt_Enc_Block_Round(plaintext, in_len,ciphertext,&out_len, masterkey, keylen,i); 
	}
	printf("\n");
#endif
	Crypt_Enc_Block(plaintext,in_len, ciphertext, &out_len,  masterkey ,  keylen);

	printf("ciphertext is:\n");
	for(  i=0;i<out_len;i++)
		printf("%02X ", ciphertext[i]);
	printf("\n");  

	printf("decrption process:\n");

	printf("ciphertext is:\n");
	for(  i=0;i<out_len;i++)
		printf("%02X ", ciphertext[i]);
	printf("\n");  
	Crypt_Dec_Block(ciphertext,in_len, plaintext, &out_len,  masterkey ,  keylen);
	printf("plaintext is:\n");
	for(  i=0;i<in_len;i++)
		printf("%02X ", plaintext[i]);
	printf("\n");     
	getchar();
	TestBallet128128_CBC();
	getchar();

	return 0;
}  

void TestBallet128128_CBC(void)
{
	u8i _C_ALIGN16(pl[256]) ;
	u8i _C_ALIGN16(MK[32]) ;
	u8i _C_ALIGN16(ref[256]) = {
		0xFD,0xD6,0xA3,0xF7,0xB7,0x01,0x32,0x30,0xE7,0x6E,0x79,0x74,0x92,0x80,0x2F,0x12
,0x5D,0xA7,0x5D,0x9B,0x37,0xAD,0x91,0x31,0xBA,0x7D,0xF8,0x0E,0xD8,0xAB,0x87,0xA4
,0xED,0xEE,0x7C,0xBE,0xC5,0xB0,0xA1,0xC1,0xEC,0xDA,0x57,0xAF,0x18,0x11,0xE2,0x96
,0x1F,0xD8,0xB2,0xC3,0xCC,0x64,0x38,0xFA,0xA7,0x29,0x05,0xC1,0x25,0xC3,0x96,0xA3
,0x01,0x88,0x85,0xE5,0x58,0x1B,0x7A,0xE6,0xD2,0x6C,0xE8,0x46,0x1C,0x73,0xD1,0x29
,0xC1,0x2B,0xE9,0xC2,0x3F,0xB3,0x13,0xE2,0x97,0x06,0xA3,0xFB,0x5F,0x53,0xF9,0x40
,0x11,0xA7,0xCD,0x1F,0xBC,0x39,0x90,0xA9,0x04,0xCD,0xB9,0x7A,0xF1,0x61,0xF2,0x0C
,0x89,0xAE,0x4E,0x58,0xD5,0x52,0x66,0x51,0xF7,0x10,0x2E,0x2D,0xDC,0x59,0x67,0xBF
,0xAA,0xD9,0x3D,0x7E,0x23,0xF8,0xB1,0xB1,0x21,0x12,0x85,0x7A,0x21,0xA7,0x10,0xB4
,0xCA,0x12,0xF9,0x0B,0xC3,0x55,0x4B,0xDE,0x73,0xA6,0x33,0x0C,0x4A,0x71,0xE3,0xC5
,0x1D,0x6C,0x3C,0x64,0x12,0x76,0xB6,0xBA,0xDF,0x6F,0x3C,0x7A,0xA7,0x14,0x01,0x15
,0xE7,0xBD,0x4F,0x19,0x08,0xD2,0xFF,0x97,0x63,0x6B,0xF9,0xBE,0x48,0x9B,0x26,0x2F
,0xA2,0x1D,0xCF,0xAD,0x98,0x44,0xAF,0x5A,0x0D,0x25,0x97,0x42,0xBE,0x26,0xBE,0xF2
,0xF7,0x82,0x0E,0x35,0x00,0x0B,0xCB,0x24,0xEE,0xAC,0xE9,0x22,0x05,0x12,0xA1,0xE0
,0x63,0xB9,0xE3,0x5F,0x72,0xF9,0xE8,0x30,0x89,0x47,0x04,0xA5,0x06,0xBC,0x17,0xFA
,0x33,0x81,0x7B,0xDD,0x6E,0x7E,0xA4,0xC5,0x52,0x0E,0x34,0xF9,0xA0,0x04,0x51,0xCC };
	u8i _C_ALIGN16(out[256]);
	u8i _C_ALIGN16(rev[256]);
	int i;
	int out_len;
	memset(pl, 0, 256);
	memset(MK, 0, 16);
	MK[7] =12;
	MK[15] = 13;

	for (i = 0; i < 256 / 4; i++)
		pl[i * 4 +3] = i;
	printf("Ballet-128/128 test vector:\n");
	printf(" pl    \n");   for (i = 0; i < 256; i++) { printf("%02X ", pl[i]);  	if ((i + 1) % 16 == 0) printf("\n"); }
	printf(" mk    \n");   for (i = 0; i < 16; i++)      printf("%02X ", MK[i]);  printf("\n");
	printf("ciphertext is:\n");
	memset(out, 0, 256);
	Crypt_Enc_Block_CBC(pl, 256, out, &out_len, MK, 16);
	printf(" cy   \n");    for (i = 0; i < 256; i++) { printf("%02X ", out[i]);  	if ((i + 1) % 16 == 0) printf("\n"); }
	printf("__ %s\n", memcmp(out, ref, 256) ? "FAIL" : "PASS");
	printf("decrption process:\n");
	Crypt_Dec_Block_CBC(out, 256, rev, &out_len, MK, 16);
	printf(" pl    \n");   for (i = 0; i < 256; i++) { printf("%02X ", rev[i]);  	if ((i + 1) % 16 == 0) printf("\n"); }
	printf("__ %s\n", memcmp(pl, rev, 256) ? "FAIL" : "PASS");
}